Loading...
Searching...
No Matches
pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT > Class Template Reference
Module registration

SampleConsensusInitialAlignment is an implementation of the initial alignment algorithm described in section IV of "Fast Point Feature Histograms (FPFH) for 3D Registration," Rusu et al. More...

`#include <pcl/registration/ia_ransac.h>`

Inheritance diagram for pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >:

## Classes

class | ErrorFunctor
class | HuberPenalty
class | TruncatedError

## Public Types

using | PointCloudSource = typename Registration< PointSource, PointTarget >::PointCloudSource
using | PointCloudSourcePtr = typename PointCloudSource::Ptr
using | PointCloudSourceConstPtr = typename PointCloudSource::ConstPtr
using | PointCloudTarget = typename Registration< PointSource, PointTarget >::PointCloudTarget
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr
using | FeatureCloud = pcl::PointCloud< FeatureT >
using | FeatureCloudPtr = typename FeatureCloud::Ptr
using | FeatureCloudConstPtr = typename FeatureCloud::ConstPtr
using | Ptr = shared_ptr< SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT > >
using | ConstPtr = shared_ptr< const SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT > >
using | ErrorFunctorPtr = typename ErrorFunctor::Ptr
using | FeatureKdTreePtr = typename KdTreeFLANN< FeatureT >::Ptr
Public Types inherited from pcl::Registration< PointSource, PointTarget, Scalar >
using | Matrix4 = Eigen::Matrix< Scalar, 4, 4 >
using | Ptr = shared_ptr< Registration< PointSource, PointTarget, Scalar > >
using | ConstPtr = shared_ptr< const Registration< PointSource, PointTarget, Scalar > >
using | CorrespondenceRejectorPtr = pcl::registration::CorrespondenceRejector::Ptr
using | KdTree = pcl::search::KdTree< PointTarget >
using | KdTreePtr = typename KdTree::Ptr
using | KdTreeReciprocal = pcl::search::KdTree< PointSource >
using | KdTreeReciprocalPtr = typename KdTreeReciprocal::Ptr
using | PointCloudSource = pcl::PointCloud< PointSource >
using | PointCloudSourcePtr = typename PointCloudSource::Ptr
using | PointCloudSourceConstPtr = typename PointCloudSource::ConstPtr
using | PointCloudTarget = pcl::PointCloud< PointTarget >
using | PointCloudTargetPtr = typename PointCloudTarget::Ptr
using | PointCloudTargetConstPtr = typename PointCloudTarget::ConstPtr
using | PointRepresentationConstPtr = typename KdTree::PointRepresentationConstPtr
using | TransformationEstimation = typename pcl::registration::TransformationEstimation< PointSource, PointTarget, Scalar >
using | TransformationEstimationPtr = typename TransformationEstimation::Ptr
using | TransformationEstimationConstPtr = typename TransformationEstimation::ConstPtr
using | CorrespondenceEstimation = pcl::registration::CorrespondenceEstimationBase< PointSource, PointTarget, Scalar >
using | CorrespondenceEstimationPtr = typename CorrespondenceEstimation::Ptr
using | CorrespondenceEstimationConstPtr = typename CorrespondenceEstimation::ConstPtr
using | UpdateVisualizerCallbackSignature = void(const pcl::PointCloud< PointSource > &, const pcl::Indices &, const pcl::PointCloud< PointTarget > &, const pcl::Indices &)
| The callback signature to the function updating intermediate source point cloud position during it's registration to the target point cloud.
Public Types inherited from pcl::PCLBase< PointSource >
using | PointCloud = pcl::PointCloud< PointSource >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| SampleConsensusInitialAlignment ()
| Constructor.
void | setSourceFeatures (const FeatureCloudConstPtr &features)
| Provide a shared pointer to the source point cloud's feature descriptors.
FeatureCloudConstPtr const | getSourceFeatures ()
| Get a pointer to the source point cloud's features.
void | setTargetFeatures (const FeatureCloudConstPtr &features)
| Provide a shared pointer to the target point cloud's feature descriptors.
FeatureCloudConstPtr const | getTargetFeatures ()
| Get a pointer to the target point cloud's features.
void | setMinSampleDistance (float min_sample_distance)
| Set the minimum distances between samples.
float | getMinSampleDistance ()
| Get the minimum distances between samples, as set by the user.
void | setNumberOfSamples (int nr_samples)
| Set the number of samples to use during each iteration.
int | getNumberOfSamples ()
| Get the number of samples to use during each iteration, as set by the user.
void | setCorrespondenceRandomness (int k)
| Set the number of neighbors to use when selecting a random feature correspondence.
int | getCorrespondenceRandomness ()
| Get the number of neighbors used when selecting a random feature correspondence, as set by the user.
void | setErrorFunction (const ErrorFunctorPtr &error_functor)
| Specify the error function to minimize.
ErrorFunctorPtr | getErrorFunction ()
| Get a shared pointer to the ErrorFunctor that is to be minimized.
Public Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
| Registration ()
| Empty constructor.
| ~Registration () override=default
| destructor.
void | setTransformationEstimation (const TransformationEstimationPtr &te)
| Provide a pointer to the transformation estimation object.
void | setCorrespondenceEstimation (const CorrespondenceEstimationPtr &ce)
| Provide a pointer to the correspondence estimation object.
virtual void | setInputSource (const PointCloudSourceConstPtr &cloud)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target)
PointCloudSourceConstPtr const | getInputSource ()
| Get a pointer to the input point cloud dataset target.
virtual void | setInputTarget (const PointCloudTargetConstPtr &cloud)
| Provide a pointer to the input target (e.g., the point cloud that we want to align the input source to)
PointCloudTargetConstPtr const | getInputTarget ()
| Get a pointer to the input point cloud dataset target.
void | setSearchMethodTarget (const KdTreePtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the target cloud.
KdTreePtr | getSearchMethodTarget () const
| Get a pointer to the search method used to find correspondences in the target cloud.
void | setSearchMethodSource (const KdTreeReciprocalPtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the source cloud (usually used by reciprocal correspondence finding).
KdTreeReciprocalPtr | getSearchMethodSource () const
| Get a pointer to the search method used to find correspondences in the source cloud.
Matrix4 | getFinalTransformation ()
| Get the final transformation matrix estimated by the registration method.
Matrix4 | getLastIncrementalTransformation ()
| Get the last incremental transformation matrix estimated by the registration method.
void | setMaximumIterations (int nr_iterations)
| Set the maximum number of iterations the internal optimization should run for.
int | getMaximumIterations ()
| Get the maximum number of iterations the internal optimization should run for, as set by the user.
void | setRANSACIterations (int ransac_iterations)
| Set the number of iterations RANSAC should run for.
double | getRANSACIterations ()
| Get the number of iterations RANSAC should run for, as set by the user.
void | setRANSACOutlierRejectionThreshold (double inlier_threshold)
| Set the inlier distance threshold for the internal RANSAC outlier rejection loop.
double | getRANSACOutlierRejectionThreshold ()
| Get the inlier distance threshold for the internal outlier rejection loop as set by the user.
void | setMaxCorrespondenceDistance (double distance_threshold)
| Set the maximum distance threshold between two correspondent points in source <-> target.
double | getMaxCorrespondenceDistance ()
| Get the maximum distance threshold between two correspondent points in source <-> target.
void | setTransformationEpsilon (double epsilon)
| Set the transformation epsilon (maximum allowable translation squared difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution.
double | getTransformationEpsilon ()
| Get the transformation epsilon (maximum allowable translation squared difference between two consecutive transformations) as set by the user.
void | setTransformationRotationEpsilon (double epsilon)
| Set the transformation rotation epsilon (maximum allowable rotation difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution.
double | getTransformationRotationEpsilon ()
| Get the transformation rotation epsilon (maximum allowable difference between two consecutive transformations) as set by the user (epsilon is the cos(angle) in a axis-angle representation).
void | setEuclideanFitnessEpsilon (double epsilon)
| Set the maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged.
double | getEuclideanFitnessEpsilon ()
| Get the maximum allowed distance error before the algorithm will be considered to have converged, as set by the user.
void | setPointRepresentation (const PointRepresentationConstPtr &point_representation)
| Provide a boost shared pointer to the PointRepresentation to be used when comparing points.
bool | registerVisualizationCallback (std::function< UpdateVisualizerCallbackSignature > &visualizerCallback)
| Register the user callback function which will be called from registration thread in order to update point cloud obtained after each iteration.
double | getFitnessScore (double max_range=std::numeric_limits< double >::max())
| Obtain the Euclidean fitness score (e.g., mean of squared distances from the source to the target)
double | getFitnessScore (const std::vector< float > &distances_a, const std::vector< float > &distances_b)
| Obtain the Euclidean fitness score (e.g., mean of squared distances from the source to the target) from two sets of correspondence distances (distances between source and target points)
bool | hasConverged () const
| Return the state of convergence after the last align run.
void | align (PointCloudSource &output)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output.
void | align (PointCloudSource &output, const Matrix4 &guess)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output.
const std::string & | getClassName () const
| Abstract class get name method.
bool | initCompute ()
| Internal computation initialization.
bool | initComputeReciprocal ()
| Internal computation when reciprocal lookup is needed.
void | addCorrespondenceRejector (const CorrespondenceRejectorPtr &rejector)
| Add a new correspondence rejector to the list.
std::vector< CorrespondenceRejectorPtr > | getCorrespondenceRejectors ()
| Get the list of correspondence rejectors.
bool | removeCorrespondenceRejector (unsigned int i)
| Remove the i-th correspondence rejector in the list.
void | clearCorrespondenceRejectors ()
| Clear the list of correspondence rejectors.
Public Member Functions inherited from pcl::PCLBase< PointSource >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointSource & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

pcl::index_t | getRandomIndex (int n)
| Choose a random index between 0 and n-1.
void | selectSamples (const PointCloudSource &cloud, unsigned int nr_samples, float min_sample_distance, pcl::Indices &sample_indices)
| Select nr_samples sample points from cloud while making sure that their pairwise distances are greater than a user-defined minimum distance, min_sample_distance.
void | findSimilarFeatures (const FeatureCloud &input_features, const pcl::Indices &sample_indices, pcl::Indices &corresponding_indices)
| For each of the sample points, find a list of points in the target cloud whose features are similar to the sample points' features.
float | computeErrorMetric (const PointCloudSource &cloud, float threshold)
| An error metric for that computes the quality of the alignment between the given cloud and the target.
void | computeTransformation (PointCloudSource &output, const Eigen::Matrix4f &guess) override
| Rigid transformation computation method.
Protected Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
bool | searchForNeighbors (const PointCloudSource &cloud, int index, pcl::Indices &indices, std::vector< float > &distances)
| Search for the closest nearest neighbor of a given point.
virtual void | computeTransformation (PointCloudSource &output, const Matrix4 &guess)=0
| Abstract transformation computation method with initial guess.
Protected Member Functions inherited from pcl::PCLBase< PointSource >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

FeatureCloudConstPtr | input_features_
| The source point cloud's feature descriptors.
FeatureCloudConstPtr | target_features_
| The target point cloud's feature descriptors.
int | nr_samples_ {3}
| The number of samples to use during each iteration.
float | min_sample_distance_ {0.0f}
| The minimum distances between samples.
int | k_correspondences_ {10}
| The number of neighbors to use when selecting a random feature correspondence.
FeatureKdTreePtr | feature_tree_
| The KdTree used to compare feature descriptors.
ErrorFunctorPtr | error_functor_
Protected Attributes inherited from pcl::Registration< PointSource, PointTarget, Scalar >
std::string | reg_name_
| The registration method name.
KdTreePtr | tree_
| A pointer to the spatial search object.
KdTreeReciprocalPtr | tree_reciprocal_
| A pointer to the spatial search object of the source.
int | nr_iterations_ {0}
| The number of iterations the internal optimization ran for (used internally).
int | max_iterations_ {10}
| The maximum number of iterations the internal optimization should run for.
int | ransac_iterations_ {0}
| The number of iterations RANSAC should run for.
PointCloudTargetConstPtr | target_
| The input point cloud dataset target.
Matrix4 | final_transformation_
| The final transformation matrix estimated by the registration method after N iterations.
Matrix4 | transformation_
| The transformation matrix estimated by the registration method.
Matrix4 | previous_transformation_
| The previous transformation matrix estimated by the registration method (used internally).
double | transformation_epsilon_ {0.0}
| The maximum difference between two consecutive transformations in order to consider convergence (user defined).
double | transformation_rotation_epsilon_ {0.0}
| The maximum rotation difference between two consecutive transformations in order to consider convergence (user defined).
double | euclidean_fitness_epsilon_
| The maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged.
double | corr_dist_threshold_
| The maximum distance threshold between two correspondent points in source <-> target.
double | inlier_threshold_ {0.05}
| The inlier distance threshold for the internal RANSAC outlier rejection loop.
bool | converged_ {false}
| Holds internal convergence state, given user parameters.
unsigned int | min_number_correspondences_ {3}
| The minimum number of correspondences that the algorithm needs before attempting to estimate the transformation.
CorrespondencesPtr | correspondences_
| The set of correspondences determined at this ICP step.
TransformationEstimationPtr | transformation_estimation_
| A TransformationEstimation object, used to calculate the 4x4 rigid transformation.
CorrespondenceEstimationPtr | correspondence_estimation_
| A CorrespondenceEstimation object, used to estimate correspondences between the source and the target cloud.
std::vector< CorrespondenceRejectorPtr > | correspondence_rejectors_
| The list of correspondence rejectors to use.
bool | target_cloud_updated_ {true}
| Variable that stores whether we have a new target cloud, meaning we need to pre-process it again.
bool | source_cloud_updated_ {true}
| Variable that stores whether we have a new source cloud, meaning we need to pre-process it again.
bool | force_no_recompute_ {false}
| A flag which, if set, means the tree operating on the target cloud will never be recomputed.
bool | force_no_recompute_reciprocal_ {false}
| A flag which, if set, means the tree operating on the source cloud will never be recomputed.
std::function< UpdateVisualizerCallbackSignature > | update_visualizer_
| Callback function to update intermediate source point cloud position during it's registration to the target point cloud.
Protected Attributes inherited from pcl::PCLBase< PointSource >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointSource, typename PointTarget, typename FeatureT>
class pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >

SampleConsensusInitialAlignment is an implementation of the initial alignment algorithm described in section IV of "Fast Point Feature Histograms (FPFH) for 3D Registration," Rusu et al.

Author
  Michael Dixon, Radu B. Rusu

Definition at line 54 of file ia_ransac.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::ConstPtr = shared_ptr< const SampleConsensusInitialAlignment<PointSource, PointTarget, FeatureT> >

Definition at line 87 of file ia_ransac.h.

## ErrorFunctorPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::ErrorFunctorPtr = typename ErrorFunctor::Ptr

Definition at line 138 of file ia_ransac.h.

## FeatureCloud

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::FeatureCloud = pcl::PointCloud<FeatureT>

Definition at line 81 of file ia_ransac.h.

## FeatureCloudConstPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::FeatureCloudConstPtr = typename FeatureCloud::ConstPtr

Definition at line 83 of file ia_ransac.h.

## FeatureCloudPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::FeatureCloudPtr = typename FeatureCloud::Ptr

Definition at line 82 of file ia_ransac.h.

## FeatureKdTreePtr

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::FeatureKdTreePtr = typename KdTreeFLANN<FeatureT>::Ptr

Definition at line 140 of file ia_ransac.h.

## PointCloudSource

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::PointCloudSource = typename Registration<PointSource, PointTarget>::PointCloudSource

Definition at line 70 of file ia_ransac.h.

## PointCloudSourceConstPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::PointCloudSourceConstPtr = typename PointCloudSource::ConstPtr

Definition at line 73 of file ia_ransac.h.

## PointCloudSourcePtr

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::PointCloudSourcePtr = typename PointCloudSource::Ptr

Definition at line 72 of file ia_ransac.h.

## PointCloudTarget

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::PointCloudTarget = typename Registration<PointSource, PointTarget>::PointCloudTarget

Definition at line 75 of file ia_ransac.h.

## PointIndicesConstPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::PointIndicesConstPtr = PointIndices::ConstPtr

Definition at line 79 of file ia_ransac.h.

## PointIndicesPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::PointIndicesPtr = PointIndices::Ptr

Definition at line 78 of file ia_ransac.h.

## Ptr

template<typename PointSource , typename PointTarget , typename FeatureT >

using pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::Ptr = shared_ptr<SampleConsensusInitialAlignment<PointSource, PointTarget, FeatureT> >

Definition at line 85 of file ia_ransac.h.

## Constructor & Destructor Documentation

## SampleConsensusInitialAlignment()

template<typename PointSource , typename PointTarget , typename FeatureT >

pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::SampleConsensusInitialAlignment | ( |  | ) |

inline

Constructor.

Definition at line 142 of file ia_ransac.h.

References pcl::Registration< PointSource, PointTarget, Scalar >::corr_dist_threshold_, pcl::Registration< PointSource, PointTarget, Scalar >::max_iterations_, pcl::Registration< PointSource, PointTarget, Scalar >::reg_name_, and pcl::Registration< PointSource, PointTarget, Scalar >::transformation_estimation_.

## Member Function Documentation

## computeErrorMetric()

template<typename PointSource , typename PointTarget , typename FeatureT >

float pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::computeErrorMetric | ( | const PointCloudSource & | cloud,
|  | float | threshold
| ) |  |

protected

An error metric for that computes the quality of the alignment between the given cloud and the target.

Parameters

  cloud | the input cloud
  threshold | distances greater than this value are capped

Definition at line 166 of file ia_ransac.hpp.

## computeTransformation()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::computeTransformation | ( | PointCloudSource & | output,
|  | const Eigen::Matrix4f & | guess
| ) |  |

override protected

Rigid transformation computation method.

Parameters

  output | the transformed input point cloud dataset using the rigid transformation found
  guess | The computed transforamtion

Definition at line 188 of file ia_ransac.hpp.

References pcl::transformPointCloud().

## findSimilarFeatures()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::findSimilarFeatures | ( | const FeatureCloud & | input_features,
|  | const pcl::Indices & | sample_indices,
|  | pcl::Indices & | corresponding_indices
| ) |  |

protected

For each of the sample points, find a list of points in the target cloud whose features are similar to the sample points' features.

From these, select one randomly which will be considered that sample point's correspondence.

Parameters

  input_features | a cloud of feature descriptors
  sample_indices | the indices of each sample point
  corresponding_indices | the resulting indices of each sample's corresponding point in the target cloud

Definition at line 141 of file ia_ransac.hpp.

## getCorrespondenceRandomness()

template<typename PointSource , typename PointTarget , typename FeatureT >

int pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getCorrespondenceRandomness | ( |  | ) |

inline

Get the number of neighbors used when selecting a random feature correspondence, as set by the user.

Definition at line 231 of file ia_ransac.h.

References pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::k_correspondences_.

## getErrorFunction()

template<typename PointSource , typename PointTarget , typename FeatureT >

ErrorFunctorPtr pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getErrorFunction | ( |  | ) |

inline

Get a shared pointer to the ErrorFunctor that is to be minimized.

Returns
  A shared pointer to a subclass of SampleConsensusInitialAlignment::ErrorFunctor

Definition at line 252 of file ia_ransac.h.

References pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::error_functor_.

## getMinSampleDistance()

template<typename PointSource , typename PointTarget , typename FeatureT >

float pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getMinSampleDistance | ( |  | ) |

inline

Get the minimum distances between samples, as set by the user.

Definition at line 195 of file ia_ransac.h.

References pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::min_sample_distance_.

## getNumberOfSamples()

template<typename PointSource , typename PointTarget , typename FeatureT >

int pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getNumberOfSamples | ( |  | ) |

inline

Get the number of samples to use during each iteration, as set by the user.

Definition at line 212 of file ia_ransac.h.

References pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::nr_samples_.

## getRandomIndex()

template<typename PointSource , typename PointTarget , typename FeatureT >

pcl::index_t pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getRandomIndex | ( | int | n | ) |

inline protected

Choose a random index between 0 and n-1.

Parameters

  n | the number of possible indices to choose from

Definition at line 262 of file ia_ransac.h.

## getSourceFeatures()

template<typename PointSource , typename PointTarget , typename FeatureT >

FeatureCloudConstPtr const pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getSourceFeatures | ( |  | ) |

inline

Get a pointer to the source point cloud's features.

Definition at line 166 of file ia_ransac.h.

References pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::input_features_.

## getTargetFeatures()

template<typename PointSource , typename PointTarget , typename FeatureT >

FeatureCloudConstPtr const pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getTargetFeatures | ( |  | ) |

inline

Get a pointer to the target point cloud's features.

Definition at line 179 of file ia_ransac.h.

References pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::target_features_.

## selectSamples()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::selectSamples | ( | const PointCloudSource & | cloud,
|  | unsigned int | nr_samples,
|  | float | min_sample_distance,
|  | pcl::Indices & | sample_indices
| ) |  |

protected

Select nr_samples sample points from cloud while making sure that their pairwise distances are greater than a user-defined minimum distance, min_sample_distance.

Parameters

  cloud | the input point cloud
  nr_samples | the number of samples to select
  min_sample_distance | the minimum distance between any two samples
  sample_indices | the resulting sample indices

Definition at line 79 of file ia_ransac.hpp.

References pcl::euclideanDistance().

## setCorrespondenceRandomness()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::setCorrespondenceRandomness | ( | int | k | ) |

inline

Set the number of neighbors to use when selecting a random feature correspondence.

A higher value will add more randomness to the feature matching.

Parameters

  k | the number of neighbors to use when selecting a random feature correspondence.

Definition at line 223 of file ia_ransac.h.

References pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::k_correspondences_.

## setErrorFunction()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::setErrorFunction | ( | const ErrorFunctorPtr & | error_functor | ) |

inline

Specify the error function to minimize.

Note
  This call is optional. TruncatedError will be used by default

Parameters

  [in] | error_functor | a shared pointer to a subclass of SampleConsensusInitialAlignment::ErrorFunctor

Definition at line 242 of file ia_ransac.h.

References pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::error_functor_.

## setMinSampleDistance()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::setMinSampleDistance | ( | float | min_sample_distance | ) |

inline

Set the minimum distances between samples.

Parameters

  min_sample_distance | the minimum distances between samples

Definition at line 188 of file ia_ransac.h.

References pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::min_sample_distance_.

## setNumberOfSamples()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::setNumberOfSamples | ( | int | nr_samples | ) |

inline

Set the number of samples to use during each iteration.

Parameters

  nr_samples | the number of samples to use during each iteration

Definition at line 204 of file ia_ransac.h.

References pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::nr_samples_.

## setSourceFeatures()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::setSourceFeatures | ( | const FeatureCloudConstPtr & | features | ) |

Provide a shared pointer to the source point cloud's feature descriptors.

Parameters

  features | the source point cloud's features

Definition at line 50 of file ia_ransac.hpp.

## setTargetFeatures()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::setTargetFeatures | ( | const FeatureCloudConstPtr & | features | ) |

Provide a shared pointer to the target point cloud's feature descriptors.

Parameters

  features | the target point cloud's features

Definition at line 64 of file ia_ransac.hpp.

## Member Data Documentation

## error_functor_

template<typename PointSource , typename PointTarget , typename FeatureT >

ErrorFunctorPtr pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::error_functor_

protected

Definition at line 325 of file ia_ransac.h.

Referenced by pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getErrorFunction(), and pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::setErrorFunction().

## feature_tree_

template<typename PointSource , typename PointTarget , typename FeatureT >

FeatureKdTreePtr pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::feature_tree_

protected

The KdTree used to compare feature descriptors.

Definition at line 323 of file ia_ransac.h.

## input_features_

template<typename PointSource , typename PointTarget , typename FeatureT >

FeatureCloudConstPtr pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::input_features_

protected

The source point cloud's feature descriptors.

Definition at line 307 of file ia_ransac.h.

Referenced by pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getSourceFeatures().

## k_correspondences_

template<typename PointSource , typename PointTarget , typename FeatureT >

int pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::k_correspondences_ {10}

protected

The number of neighbors to use when selecting a random feature correspondence.

Definition at line 320 of file ia_ransac.h.

Referenced by pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getCorrespondenceRandomness(), and pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::setCorrespondenceRandomness().

## min_sample_distance_

template<typename PointSource , typename PointTarget , typename FeatureT >

float pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::min_sample_distance_ {0.0f}

protected

The minimum distances between samples.

Definition at line 316 of file ia_ransac.h.

Referenced by pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getMinSampleDistance(), and pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::setMinSampleDistance().

## nr_samples_

template<typename PointSource , typename PointTarget , typename FeatureT >

int pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::nr_samples_ {3}

protected

The number of samples to use during each iteration.

Definition at line 313 of file ia_ransac.h.

Referenced by pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getNumberOfSamples(), and pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::setNumberOfSamples().

## target_features_

template<typename PointSource , typename PointTarget , typename FeatureT >

FeatureCloudConstPtr pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::target_features_

protected

The target point cloud's feature descriptors.

Definition at line 310 of file ia_ransac.h.

Referenced by pcl::SampleConsensusInitialAlignment< PointSource, PointTarget, FeatureT >::getTargetFeatures().

The documentation for this class was generated from the following files:

- pcl/registration/ia_ransac.h
- pcl/registration/impl/ia_ransac.hpp